// Implementation of
//  Circle class
//  
//
//  Created by Denise Byrnes on 2/8/14.
//  Copyright (c) 2014 Denise Byrnes. All rights reserved.
//

#include "SimpleCircleStruct.h"
using std::cout;
using std::endl;
using std::ostream;
using std::istream;

//Creates a Circle object
//pre:none
//post: Circle is created with default values
void CreateCircle(Circle &c)
{
    c.xCenter = c.yCenter = c.radius = 0.0;
}

//Sets the x center value of a Circle object
//pre:none
//post: center c.x coordinate of Circle is set to x
void setX(float x, Circle &c)
{
    c.xCenter = x;
}

//Sets the y center value of a Circle object
//pre:none
//post: center c.y coordinate of Circle is set to y
void setY(float y, Circle &c)
{
    c.yCenter = y;
}

//Sets the radius value of a Circle object
//pre:r >= 0
//post: radius of Circle is set to r
//checks: c.r >= 0
void setRadius (float r, Circle &c)
{
    if( r >= 0)c.radius = r;
}

//Sets the x,y center values and radius of a Circle object
//pre:r >= 0
//post: center c.x coordinate of Circle is set to x
//      center c.y coordinate of Circle is set to y
//      radius of Circle is set to r
//checks: r >= 0

void setCircle(float x, float y, float r, Circle &c)
{
    c.xCenter = x;
    c.yCenter = y;
    if( r >= 0)c.radius = r;
}

//Accessors (getters)
//Returns the x center value of a Circle object
//pre:none
//post: returns x center coordinate
float getX(const Circle &c)
{
    return c.xCenter;
}

//Returns the y center value of a Circle object
//pre:none
//post: returns y center coordinate
float getY(const Circle &c)
{
    return c.yCenter;
}

//Returns the radius of a Circle object
//pre:none
//post: returns radius of Circle
float getRadius(const Circle &c)
{
    return c.radius;
}

//Returns true if the radius of this circle is < radius of circle1
//pre:none
//post: true if radius of c < radius of c1, false otherwise, Circle objects are not modified
bool operator<(const Circle &c, const Circle &c1)
{
    return c.radius < c1.radius;
}

//Returns true if c is == c1
//pre:none
//post: true if this c == c1, false otherwise,
//Circle objects are not modified
bool operator==(const Circle &c, const Circle &c1)
{
    return ((c.radius == c1.radius) && (c.xCenter == c1.xCenter) && (c.yCenter == c1.yCenter));
}


//Outputs a Circle object to the output stream
//pre:none
//post: Circle object is displayed
ostream& operator<<(ostream & out, const Circle &c)
{
    out<< " Circle radius = " << c.radius << endl;
    out << " Circle is centered at " << c.xCenter << "," << c. yCenter << endl;
    return out;
}

//Inputs a Circle object from the input stream
//pre:none
//post: Circle object is read from input stream
istream& operator>>(istream & in, Circle &c)
{
    cout << "Please enter the circle radius ";
    in >> c.radius;
    cout << "Please enter the x and y real values for the circle center ";
    in >> c.xCenter >> c.yCenter;
    return in;
}
